
import { StandardDataSource } from "pont-engine";
const pontConfig = require('../../../../pont-config.json')

export default function (dataSource: StandardDataSource): StandardDataSource {
  let datasourceName = dataSource.name
  let origins = pontConfig.origins
  let findObj = origins.find(ele => ele.name === datasourceName)
  if (findObj) {
    let basePath = findObj.basePath
    let mods = dataSource.mods
    mods.forEach(mod => {
      let interfaces = mod.interfaces
      interfaces.forEach(inter => {
        inter.path = (basePath?basePath:'') + inter.path
      })
    })
  }
  return dataSource;
}
